% Function to calculate addition operation in elliptic curve arithmetics
% sum of two elliptic curve points, over Prime Fine Field (Fp)
% p : rime number value (input parameter)
% A : Coefficient Elliptic Curve of A in this equation y^2 = x^3 + Ax + B (input parameter)
% PP : Elliptic curve point (input parameter)
% PQ : Elliptic curve point (input parameter)
% R :  Point P (PP) +  Point Q (PQ)       <----- output
%     R = PP + PQ  
function R=eccadd(p,A,PP,PQ)
if ((PP=='O') | (PP=='o'))
    R=PQ;
elseif ((PQ=='O') | (PQ=='o'))
    R=PP;
elseif ((PP(1)==PQ(1)) & (PQ(2)==mod(-PP(2),p)))
    R='O';
elseif ((PP(1)==PQ(1)) & (PP(2)==PQ(2)))
    d11=eccfkali(PP(1),PP(1),p);
    d12=eccfkali(3,d11,p);
    d1=eccfadd(d12,A,p);
    d2=eccfkali(2,PQ(2),p);
    d=eccfbagi(d1,d2,p);     
    xr1=eccfkali(d,d,p);
    xr2=mod(xr1-PP(1),p);
    xr=mod(xr2-PQ(1),p);
    yr1=mod(PP(1)-xr,p);
    yr2=eccfkali(d,yr1,p);
    yr=mod(yr2-PP(2),p);
    R(1)=xr;
    R(2)=yr;
else
    d1=mod(PQ(2)-PP(2),p);
    d2=mod(PQ(1)-PP(1),p);
    d=eccfbagi(d1,d2,p);
    xr1=eccfkali(d,d,p);
    xr2=mod(xr1-PP(1),p);
    xr=mod(xr2-PQ(1),p);
    yr1=mod(PP(1)-xr,p);
    yr2=eccfkali(d,yr1,p);
    yr=mod(yr2-PP(2),p);
    R(1)=xr;
    R(2)=yr;
end