% Function to calculate the scalar multiplication 'k' and elliptic curve point 'PP'
% using addition-subtraction algorithm.
% Point p (PP) is the point of elliptic curve E (A, B)  over Prime Finite Field *Fp) .
% 'k' is scalar (integer) and 'k' is elements of Fp
% p : rime number value (input parameter)
% A : Coefficient Elliptic Curve of A in this equation y^2 = x^3 + Ax + B (input parameter)
% k : Scalar multiplication (input parameter)
% PP : Elliptic curve point (input parameter)
% R :  'k' multiplied by Point P (PP) 
%     R = k * PP
function R=eccaddsub(p,A,k,PP)
u=eccnaf(k);
R='O';
for j=length(u):-1:1
    R=eccadd(p,A,R,R);
    if(u(j)==1)
        R=eccadd(p,A,R,PP);
    elseif (u(j)==-1)
        negP=eccneg(p,PP);
        R=eccadd(p,A,R,negP);
    end
end